#include "touch.h"

#if defined(_DEBUG_INTERFACE_) && defined(QDEBUG_TWI)

#include <avr/io.h>
#include <avr/interrupt.h>
#include "TWI_Master.h"
#include "QDebugTransport.h"

#if defined(QDEBUG_SPI)
  #warning "TWI driver should not be included if SPI is defined as debug interface"
#endif

static unsigned char TWI_addr;				// MɏՕʒu
static unsigned int TWI_msgSize;			// Mׂ޲Đ

union TWI_statusReg TWI_statusReg = {0};	// TWI_statusRegTWI_Master.hŒ`܂B

/****************************************************************************
TWI呕ȕҋ@Ԃɍ\ݒ肷邽߂ɂ̊֐ĂłB
TWIɎ剞p犄荞݂邱ƂYȂłB
****************************************************************************/
void TWI_Master_Init (void)
{
	TWBR = TWI_BAUDSETTING;						// ޯđxڼ޽(ްڰ)ݒBͯ ̧قŒ`
//	TWSR = TWI_TWPS;							// sgpBײނ͑Ou'00'Ɖ
	TWDR = 0xFF;								// e=SDAJ
	TWCR = (1<<TWEN)|							// TWI̪ATWI݊J
		   (0<<TWIE)|(0<<TWINT)|				// 荞݋֎~
		   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// }MvȂ
		   (0<<TWWC);							//
}

/****************************************************************************
TWI_ISRMZ𒲂ׂ邽߂ɂ̊֐ĂłB
****************************************************************************/
unsigned char TWI_Transceiver_Busy (void)
{
	return ( TWCR & (1<<TWIE) );				// TWI荞݂Ȃ΁AM͑Z
}

void TWI_Send_Message (void)
{
	TWI_msgSize = ((TX_Buffer[1]<<8)+TX_Buffer[2]);		// Mް
	TWI_addr  =(TWISLAVE_ADDR<<TWI_ADR_BITS) | (FALSE<<TWI_READ_BIT);	// R/WݒƋɏ]uڽi[
	TWI_statusReg.all = 0;
	TWCR = (1<<TWEN)|							// TWI̪
		   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋A׸މ
		   (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|		// JnJn
		   (0<<TWWC);							//
	while ( TWI_Transceiver_Busy() );			// ̑M܂őҋ@
}

void TWI_Retrieve_Message (void)
{
	unsigned int i;

	TWI_addr  = (TWISLAVE_ADDR<<TWI_ADR_BITS) | (TRUE<<TWI_READ_BIT);
	TWI_statusReg.all = 0;
	TWCR = (1<<TWEN)|							// TWI̪
		   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋A׸މ
		   (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|		// JnJn
		   (0<<TWWC);							//
	while ( TWI_Transceiver_Busy() );			// ̑M܂őҋ@

	if( ! TWI_statusReg.lastTransOK )			// Ō̑MɊŁA
		for ( i=0; i<=TWI_msgSize; i++ )		// MɏՕް𕡎
			RX_Buffer[i] = 0;					// MsȂް
}

// ********** 荞ݏ ********** //
/****************************************************************************
̊֐͊荞ݏٰ(ISR:Interrupt Service Routine)ŁATWI荞݂N
鎞ATWIۂNɕKĂ΂܂B̊֐͎剞p璼ڌĂ΂
ׂłB
TWINT͎IɉꂸAISRŎ蓮ŉȂ΂Ȃ܂B
****************************************************************************/

ISR(TWI_vect)
{
	static unsigned int TWI_bufPtr;
	volatile unsigned char FrameInProgress;

	switch (TWSR)
	{
		case TWI_START:							// JnM

		case TWI_REP_START:						// đJnM
			TWI_bufPtr = 0;						// TWIڽʒuɊɏՕʒuwqݒ
			TWDR = TWI_addr;
			TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			break;

		case TWI_MTX_ADR_ACK:					// SLA+WMAACKM
		case TWI_MTX_DATA_ACK:					// ް ޲đMAACKM
			if (TWI_bufPtr <= TWI_msgSize)
			{
				TWDR = TX_Buffer[TWI_bufPtr++];
				TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			}
			else								// ŏI޲Čɒ~o
			{
				TWI_statusReg.lastTransOK = TRUE;	// ׸ނ𐬌ɐݒ
				TWCR = (1<<TWEN)|(0<<TWIE)|(1<<TWINT)|(1<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|(0<<TWWC);
			}
			break;

		case TWI_MRX_ADR_ACK:					// SLA+RMAACKM
			TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			break;

		case TWI_MRX_DATA_ACK:					// ް ޲ĎMAACKM
			FrameInProgress=RxHandler(TWDR);
			if (FrameInProgress )				// NACKɂŏI޲Ăo
			{
				// MACKo
				TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			}
			else
			{
//				TWI_Protocol_State=TWI_STATE_MSG_START;		// TWIVK߹ĎM
				// MNACKo
				TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			}
			break;

		case TWI_MRX_DATA_NACK:					// ް ޲ĎMANACKM
			RxHandler(TWDR);
			TWI_statusReg.lastTransOK = TRUE;	// ׸ނ𐬌ɐݒ
			// Initiate a STOP condition.
			TWCR = (1<<TWEN)|(0<<TWIE)|(1<<TWINT)|(0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|(0<<TWWC);
			break;

		case TWI_ARB_LOST:						// s
			// (đ)JnJn
			TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			break;

		case TWI_MTX_ADR_NACK:					// SLA+WMANACKM
		case TWI_MRX_ADR_NACK:					// SLA+RMANACKM
		case TWI_MTX_DATA_NACK:					// ް ޲đMANACKM
//		case TWI_NO_STATE						// p\Ȋ֘AԏȂ(`TWINT)
		case TWI_BUS_ERROR:						// sȊJn܂͒~̂߂޽ُ
		default:
			// TWI̪ ؾ
			TWCR = (1<<TWEN)|						// TWI̪ATWI݊J
				   (0<<TWIE)|(0<<TWINT)|			// TWI荞݋֎~
				   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// }MvȂ
				   (0<<TWWC);						//
	}
}
#endif/* _DEBUG_INTERFACE_*/

//**********************************************************************************************************
