/*******************************************************************************
*   $FILE: QDebug.c
*   Atmel Corporation: http://www.atmel.com \n
*   xEҰ: touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/

#include "touch.h"

#ifdef _DEBUG_INTERFACE_

/*----------------------------------------------------------------------------
ݸٰ ̧
----------------------------------------------------------------------------*/
#include "touch_api.h"
#include "QDebug.h"
#include "QDebugTransport.h"
#include "QDebugSettings.h"

#if !(defined(__AVR32__) || defined(__ICCAVR32__) || defined(_TOUCH_ARM_))
  #include "eeprom_access.h"
#endif

#if defined(QDEBUG_SPI)
  #include "SPI_Master.h"
#elif defined(QDEBUG_TWI)
  #include "TWI_Master.h"
#elif defined(QDEBUG_SPI_BB)
  #include "BitBangSPI_Master.h"
#else
  #warning "No Debug Interface is selected in QDebugSettings.h"
#endif

/*----------------------------------------------------------------------------
Sϐ
----------------------------------------------------------------------------*/
uint8_t qgRefschanged;
uint8_t qgStateschanged;
qt_lib_siginfo_t lib_siginfo;

/*----------------------------------------------------------------------------
Oϐ
----------------------------------------------------------------------------*/
extern uint8_t RX_Buffer[];
extern uint8_t num_sensors;
extern sensor_t sensors[];
#if defined (_QDEBUG_TIME_STAMPS_)
  extern uint16_t timestamp0_hword;
  extern uint16_t timestamp0_lword;
  extern uint16_t timestamp1_hword;
  extern uint16_t timestamp1_lword;
  extern uint16_t timestamp2_hword;
  extern uint16_t timestamp2_lword;
  extern uint16_t timestamp3_hword;
  extern uint16_t timestamp3_lword;
  extern uint16_t timestamp4_hword;
  extern uint16_t timestamp4_lword;
#endif
extern void set_timer_period(uint16_t qt_measurement_period_msec);
/*----------------------------------------------------------------------------
ÓIϐ
----------------------------------------------------------------------------*/
static uint16_t delivery = 0;
static uint16_t qgSubsOnce = 0;
static uint16_t qgSubsChange = 0;
static uint16_t qgSubsAllways = 0;
static uint16_t qgLibraryChanges = 0;

/*----------------------------------------------------------------------------
֐^
----------------------------------------------------------------------------*/
#ifdef _OPT_SRAM_
static void Msg_Start_Routine (uint16_t msg_length);
static void Msg_End_Routine (void);
#endif
/*============================================================================
O: QDebug_Init
------------------------------------------------------------------------------
ړI: ޯ ̪
: Ȃ
o: Ȃ
: JԂ̑OɌĂ΂Ȃ΂Ȃ܂B
============================================================================*/
void QDebug_Init (void)
{
#if !(defined(__AVR32__) || defined(__ICCAVR32__) || defined(_TOUCH_ARM_))
	uint16_t eeprom_lib_version;
#endif
#if defined(QDEBUG_SPI)
	SPI_Master_Init();
#elif defined(QDEBUG_TWI)
	TWI_Master_Init();
#elif defined(QDEBUG_SPI_BB)
	BitBangSPI_Master_Init();
#endif
	qt_get_library_sig(&lib_siginfo);
	Init_Buffers();
	/* EEPROMݒ茒S */
#if !(defined(__AVR32__) || defined(__ICCAVR32__) || defined(_TOUCH_ARM_))
	eeprom_lib_version = read_info_from_eeprom();
	if(eeprom_lib_version == lib_siginfo.library_version)
	{
		read_settings_from_eeprom();
	}
	else
	{
		write_info_to_eeprom(lib_siginfo.library_version);
		write_global_settings_to_eeprom();
		write_sensor_settings_to_eeprom();
  #ifdef _QMATRIX_
		write_burst_lenghts_to_eeprom();
  #endif
	}
#endif
}

/*============================================================================
O: QDebug_ProcessCommands
------------------------------------------------------------------------------
ړI: QTouch Studio󂯎ް̂߂̖ߏ
: Ȃ
o: Ȃ
: ̊֐QTouch Studio󂯎ް邽߂measure_sensors
	  ɎJԂŌĂ΂ׂłB
============================================================================*/
void QDebug_ProcessCommands (void)
{
	uint8_t CommandID;

	/* ؂Ŏgpް̂߂ɱڽ𖞂B */
	uint8_t *pdata = 0;
	uint8_t time_setting = 0;			// ̎gp̂߂ɎԐݒ

	if (Receive_Message() == 0)
		return;
	// ߏ
	CommandID = GetChar();
	switch (CommandID)
	{
		case QT_CMD_DUMMY:
			break;
		case QT_CMD_SET_SUBS:
			Set_Subscriptions();
			break;
		case QT_CMD_SET_GLOBAL_CONFIG:
			Set_Global_Config();
			time_setting = GetChar();	// ̎gp̂߂ɎԐݒ
			break;
		case QT_CMD_SET_CH_CONFIG:
			Set_Channel_Config();
			break;
#ifdef _QMATRIX_
		case QT_CMD_SET_QM_BURST_LENGTHS:
			Set_QM_Burst_Lengths();
			break;
#endif
		case QT_CMD_SET_USER_DATA:
			Set_QT_User_Data(pdata);
			break;
	}
	RX_Buffer[0]=0;
	RX_index=0;
}

/*============================================================================
O: QDebug_SendData
------------------------------------------------------------------------------
ړI: ɊÂQTouch Studioް𑗏o
: measure_sensors̕ύX׸
o: Ȃ
: ̊֐͑肵ް𑗂邽߂measure_sensorsɎJԂŌĂ΂
	  ׂłB
============================================================================*/
void QDebug_SendData (uint16_t qt_lib_flags)
{
#if defined (_QDEBUG_TIME_STAMPS_)
	uint8_t *pdata = NULL;
	uint16_t c = 0;
#endif
	SequenceH = (SequenceH+1)&0x0F;
	/* measure_sensorsԂ܂͉]q/q̈ʒuł̕ύX񍐂 */
	if((qt_lib_flags & QTLIB_STATUS_CHANGE) ||
	   (qt_lib_flags & QTLIB_ROTOR_SLIDER_POS_CHANGE) )
	{
		qgLibraryChanges |= (1<<SUBS_STATES);
	}
	/* measure_sensorsŒ1َQƊł̕ύX񍐂 */
	if(qt_lib_flags & QTLIB_CHANNEL_REF_CHANGE)
	{
		qgLibraryChanges |= (1<<SUBS_REF);
	}
#if defined (_QDEBUG_TIME_STAMPS_)
	// IHp:ɎԈ𑗏o
	qgSubsAllways |= (1<<SUBS_TIMESTAMPS);
	// IHp:Ɏgpް𑗏o
	qgSubsAllways |= (1<<SUBS_USER_DATA);
#endif
	delivery = qgSubsAllways | qgSubsOnce | (qgLibraryChanges & qgSubsChange);

	if (delivery & (1<<SUBS_SIGN_ON))
		Transmit_Sign_On();
	if (delivery & (1<<SUBS_GLOBAL_CONFIG))
		Transmit_Global_Config();
	if (delivery & (1<<SUBS_SENSOR_CONFIG))
		Transmit_Sensor_Config();
	if (delivery & (1<<SUBS_SIGNALS))
		Transmit_Signals();
	if (delivery & (1<<SUBS_REF))
		Transmit_Ref();
	if (delivery & (1<<SUBS_STATES))
		Transmit_State();
	if (delivery & (1<<SUBS_DELTA))
		Transmit_Delta();
#ifdef _QMATRIX_
	if (delivery & (1<<SUBS_QM_BURST_LENGTHS))
		Transmit_Burst_Lengths();
#endif
#if defined (_QDEBUG_TIME_STAMPS_)
	if (delivery & (1<<SUBS_TIMESTAMPS))
		Transmit_Time_Stamps(qt_lib_flags);
	if (delivery & (1<<SUBS_USER_DATA))
		Transmit_QT_User_Data(pdata, c);
#endif
	if (delivery == 0)
		Transmit_Dummy();
	// PCʂ̗v𑗂܂ŎՕؾ
	qgSubsOnce = 0;
	// PɑύXؾ
	qgLibraryChanges &= ~delivery;
}

/*============================================================================
O: QDebug_SetSubscriptions
------------------------------------------------------------------------------
ړI: lݒ
: l
o: Ȃ
: ̊֐1SPI̪gpꍇްݒ肷邽߂
	  mainŒڎgp邱Ƃł܂B
============================================================================*/
void QDebug_SetSubscriptions (uint16_t once, uint16_t change, uint16_t allways)
{
	qgSubsOnce = once;
	qgSubsChange = change;
	qgSubsAllways = allways;
}

/*============================================================================
O: SetSubscriptions
------------------------------------------------------------------------------
ړI: ްlݒ
: Ȃ
o: Ȃ
: ߏ炾Ă΂ׂłB
============================================================================*/
void Set_Subscriptions (void)
{
	uint16_t temp;

	temp = GetChar() << 8;				// ޯ8`15
	uint16_t a = temp | GetChar();

	temp = GetChar() << 8;				// ޯ8`15
	uint16_t b = temp | GetChar();

	temp = GetChar() << 8;				// ޯ8`15
	uint16_t c = temp | GetChar();
	QDebug_SetSubscriptions(a, b, c);
}

/*============================================================================
O: Set_Global_Config
------------------------------------------------------------------------------
ړI: QTouch Studioް ߹ĒoASʌ`Ԑݒݒ
: Ȃ
o: Ȃ
: ߏ炾Ă΂ׂłB
============================================================================*/
void Set_Global_Config (void)
{
	qt_config_data.qt_recal_threshold = (recal_threshold_t)GetChar();
	qt_config_data.qt_di              = GetChar();
	qt_config_data.qt_drift_hold_time = GetChar();
	qt_config_data.qt_max_on_duration = GetChar();
	qt_config_data.qt_neg_drift_rate  = GetChar();
	qt_config_data.qt_pos_drift_rate  = GetChar();
	qt_config_data.qt_pos_recal_delay = GetChar();
	qt_measurement_period_msec        = (GetChar() << 8u);
	qt_measurement_period_msec       |= GetChar();

	set_timer_period(qt_measurement_period_msec);
#if !(defined(__AVR32__) || defined(__ICCAVR32__) || defined(_TOUCH_ARM_))
	write_global_settings_to_eeprom();
#endif
}

/*============================================================================
O: Set_Channel_Config
------------------------------------------------------------------------------
ړI: QTouch Studioް ߹Ă𒊏oٌ`Ԑݒݒ
:
o:
: ߏ炾Ă΂ׂłB
============================================================================*/
void Set_Channel_Config (void)
{
	uint8_t sensor_number;
	uint8_t sensor_aks_hyst;

	sensor_number = GetChar();
	sensors[sensor_number].threshold = GetChar();
	sensor_aks_hyst = GetChar();

	/* AKS˽ؼ̈悾ݒ(00111011) */
	sensors[sensor_number].type_aks_pos_hyst = \
		(sensors[sensor_number].type_aks_pos_hyst & (0xC4u)) | (sensor_aks_hyst & ~(0xC4u));

#if !(defined(__AVR32__) || defined(__ICCAVR32__) || defined(_TOUCH_ARM_))
	write_sensor_settings_to_eeprom();
#endif
}

#ifdef _QMATRIX_
/*============================================================================
O: Set_QM_Burst_Lengths
------------------------------------------------------------------------------
ړI: QMatrixWݒ
:
o:
: ߏ炾Ă΂ׂłB
============================================================================*/
void Set_QM_Burst_Lengths (void)
{
	uint8_t c = 0;
	while( c < QT_NUM_CHANNELS )
	{
		qt_burst_lengths[c++] = GetChar();
	}
  #if !(defined(__AVR32__) || defined(__ICCAVR32__) || defined(_TOUCH_ARM_))
	write_burst_lenghts_to_eeprom();
  #endif
}
#endif

/*============================================================================
O: Set_QT_User_Data
------------------------------------------------------------------------------
ړI: gpްQTouch StudioڐGMCU؂֒o
: ް ߲
o: Ȃ
: ް2iްŗL蓾܂B
============================================================================*/
void Set_QT_User_Data (uint8_t *pdata)
{
	uint16_t c = RX_Buffer[1];
#ifdef _OPT_SRAM_
	Msg_Start_Routine(4u + c);
#endif
	while( c > 0 )
	{
		PutChar(*pdata++);
		c--;
	}
#ifdef _OPT_SRAM_
	Msg_End_Routine();
#else
	Send_Message();
#endif
}

/*============================================================================
O: Transmit_Dummy
------------------------------------------------------------------------------
ړI: ̏ݒ肳ĂȂΉ߹đM
: Ȃ
o: Ȃ
:
============================================================================*/
void Transmit_Dummy (void)
{
#ifdef _OPT_SRAM_
	Msg_Start_Routine(TX_PKT_HEADER_LENGTH);
#endif
	PutChar(QT_DUMMY);
#ifdef _OPT_SRAM_
	Msg_End_Routine();
#else
	Send_Message();
#endif
}

/*============================================================================
O: Transmit_Sign_On
------------------------------------------------------------------------------
ړI: QTouch Studio֏M
: Ȃ
o: Ȃ
:
============================================================================*/
void Transmit_Sign_On (void)
{
#ifdef _OPT_SRAM_
	Msg_Start_Routine(TX_SIGN_ON_PKT_LENGTH);
#endif
	PutChar(QT_SIGN_ON);
	PutInt(PROJECT_ID);
	PutChar(INTERFACE);
	PutChar(1);								// PROTOCOL_TYPE
	PutChar(2);								// PROTOCOL_VERSION
	PutChar(lib_siginfo.lib_sig_lword);		// LIB_TYPE
	PutInt(lib_siginfo.library_version);	// LIB_VERSION
	PutInt(0);								// LIB_VARIANT
	PutChar(QT_NUM_CHANNELS);
	PutInt(delivery);						// 
#ifdef _OPT_SRAM_
	Msg_End_Routine();
#else
	Send_Message();
#endif
}

/*============================================================================
O: Transmit_Global_Config
------------------------------------------------------------------------------
ړI: QTouch Studio֑Sʌ`Ԑݒ\̑M
: Ȃ
o: Ȃ
:
============================================================================*/
void Transmit_Global_Config (void)
{
#ifdef _OPT_SRAM_
	Msg_Start_Routine(TX_GLOBAL_CONFIG_PKT_LENGTH);
#endif
	PutChar(QT_GLOBAL_CONFIG);
	PutChar(qt_config_data.qt_recal_threshold);
	PutChar(qt_config_data.qt_di);
	PutChar(qt_config_data.qt_drift_hold_time);
	PutChar(qt_config_data.qt_max_on_duration);
	PutChar(qt_config_data.qt_neg_drift_rate);
	PutChar(qt_config_data.qt_pos_drift_rate);
	PutChar(qt_config_data.qt_pos_recal_delay);
	PutInt(qt_measurement_period_msec);
	PutInt(TICKS_PER_MS);
	PutChar(0);								// Time_Setting
#ifdef _OPT_SRAM_
	Msg_End_Routine();
#else
	Send_Message();
#endif
}

/*============================================================================
O: Transmit_Sensor_Config
------------------------------------------------------------------------------
ړI: QTouch Studioٌ`Ԑݒ\̑M
: Ȃ
o: Ȃ
:
============================================================================*/
void Transmit_Sensor_Config (void)
{
	uint8_t c;
#ifdef _OPT_SRAM_
  #ifdef _ROTOR_SLIDER_
	Msg_Start_Routine(TX_SENSOR_CONFIG_PKT_LENGTH);
  #else
	Msg_Start_Routine(TX_SENSOR_CONFIG_PKT_LENGTH);
  #endif
#endif
	PutChar(QT_SENSOR_CONFIG);
  #ifdef _ROTOR_SLIDER_
	PutChar(1);								// 1=KRS
	for(c=0; c<num_sensors; c++)
	{
		PutChar(sensors[c].threshold);
		PutChar(sensors[c].type_aks_pos_hyst);
		PutChar(sensors[c].from_channel);
		PutChar(sensors[c].to_channel);
	}
  #else
	PutChar(0);								// 0=K
	for(c=0; c<num_sensors; c++)
	{
		PutChar(sensors[c].threshold);
		PutChar(sensors[c].type_aks_pos_hyst);
		PutChar(sensors[c].from_channel);
	}
  #endif
#ifdef _OPT_SRAM_
	Msg_End_Routine();
#else
	Send_Message();
#endif
}

/*============================================================================
O: Transmit_Signals
------------------------------------------------------------------------------
ړI: eقɑ΂鑪lQTouch Studio֑M
: Ȃ
o: Ȃ
:
============================================================================*/
void Transmit_Signals (void)
{
	uint8_t c;
#ifdef _OPT_SRAM_
	Msg_Start_Routine(TX_SIGNALS_PKT_LENGTH);
#endif
	PutChar(QT_SIGNALS);
	for(c=0; c<QT_NUM_CHANNELS; c++)
	{
		PutChar(qt_measure_data.channel_signals[c] >> 8);
		PutChar(qt_measure_data.channel_signals[c] & 0xFF);
	}
#ifdef _OPT_SRAM_
	Msg_End_Routine();
#else
	Send_Message();
#endif
}

/*============================================================================
O: Transmit_Ref
------------------------------------------------------------------------------
ړI: َQƊlQTouch Studio֑M
: Ȃ
o: Ȃ
:
============================================================================*/
void Transmit_Ref (void)
{
	uint8_t c;
#ifdef _OPT_SRAM_
	Msg_Start_Routine(TX_REFERENCE_PKT_LENGTH);
#endif
	PutChar(QT_REFERENCES);
	for(c=0; c<QT_NUM_CHANNELS; c++)
	{
		PutChar(qt_measure_data.channel_references[c] >> 8);
		PutChar(qt_measure_data.channel_references[c] & 0xFF);
	}
#ifdef _OPT_SRAM_
	Msg_End_Routine();
#else
	Send_Message();
#endif
}

/*============================================================================
O: Transmit_Delta
------------------------------------------------------------------------------
ړI: ٍlQTouch Studio֑M
: Ȃ
o: Ȃ
: ̒l͐M-QƊƓłB
============================================================================*/
void Transmit_Delta (void)
{
	uint8_t c;
	uint16_t delta;
#ifdef _OPT_SRAM_
	Msg_Start_Routine(TX_DELTA_PKT_LENGTH);
#endif
	PutChar(QT_DELTAS);
	for (c=0; c < num_sensors; c++)
	{
		delta=qt_get_sensor_delta(c);
		PutChar(delta >> 8);
		PutChar(delta & 0xFF);
	}
#ifdef _OPT_SRAM_
	Msg_End_Routine();
#else
	Send_Message();
#endif
}

/*============================================================================
O: Transmit_State
------------------------------------------------------------------------------
ړI: ԒlQTouch Studio֑M
: Ȃ
o: Ȃ
: emɑ΂ON/OFF
============================================================================*/
void Transmit_State (void)
{
	uint8_t c;
#ifdef _OPT_SRAM_
	Msg_Start_Routine(TX_STATE_PKT_LENGTH);
#endif
	PutChar(QT_STATES);
	PutChar(QT_NUM_CHANNELS);
	PutChar(QT_MAX_NUM_ROTORS_SLIDERS);
	for (c = 0; c < QT_NUM_SENSOR_STATE_BYTES; c++)
	{
		PutChar(qt_measure_data.qt_touch_status.sensor_states[c]);
	}
#ifdef _ROTOR_SLIDER_
	for (c=0; c<QT_MAX_NUM_ROTORS_SLIDERS; c++)
	{
		// 3.2 ύX - ]q/q̒l͍8ޯ
		PutChar(qt_measure_data.qt_touch_status.rotor_slider_values[c]);
	}
#endif
#ifdef _OPT_SRAM_
	Msg_End_Routine();
#else
	Send_Message();
#endif
}

#ifdef _QMATRIX_
/*============================================================================
O: Transmit_Burst_Lengths
------------------------------------------------------------------------------
ړI: QMatrixWlQTouch Studio֑M
: Ȃ
o: Ȃ
: ̒l͊eقɑ΂ėp\łB
============================================================================*/
void Transmit_Burst_Lengths (void)
{
  #ifdef _OPT_SRAM_
	Msg_Start_Routine(TX_BURST_LEN_PKT_LENGTH);
  #endif
	PutChar(QT_QM_BURST_LENGTHS);
	uint8_t c = 0;
	while( c < QT_NUM_CHANNELS )
	{
		PutChar(qt_burst_lengths[c++]);
	}
  #ifdef _OPT_SRAM_
	Msg_End_Routine();
  #else
	Send_Message();
  #endif
}
#endif

#if defined (_QDEBUG_TIME_STAMPS_)
/*============================================================================
O: Transmit_Time_Stamps
------------------------------------------------------------------------------
ړI: psԈlQTouch Studio֑M
: Ȃ
o: Ȃ
: ̒lcurrent_time_ms_touch(ʌ)ƌvvڼ޽(ʌ)̑gݍ
	  łB
============================================================================*/
void Transmit_Time_Stamps (uint16_t qt_lib_flags)
{
  #ifdef _OPT_SRAM_
	Msg_Start_Routine(TX_TIME_STAMPS_PKT_LENGTH);
  #endif
	PutChar(QT_TIMESTAMPS);
	PutInt(timestamp0_hword);
	PutInt(timestamp0_lword);
	PutInt(timestamp1_hword);
	PutInt(timestamp1_lword);
	PutInt(timestamp2_hword);
	PutInt(timestamp2_lword);
	PutInt(timestamp3_hword);
	PutInt(timestamp3_lword);
	PutInt(timestamp4_hword);
	PutInt(timestamp4_lword);
	PutInt(qt_lib_flags);
  #ifdef _OPT_SRAM_
	Msg_End_Routine();
  #else
	Send_Message();
  #endif
}

/*============================================================================
O: Transmit_QT_User_Data
------------------------------------------------------------------------------
ړI: gpްQTouch Studio֑M
: ް ߲A޲Ăłް̒
o: Ȃ
: ް2iްłB
============================================================================*/
void Transmit_QT_User_Data (uint8_t *pdata, uint16_t c)
{
  #ifdef _OPT_SRAM_
	Msg_Start_Routine(TX_PKT_HEADER_LENGTH + c);
  #endif
	PutChar(QT_USER_DATA);
	while( c > 0 )
	{
		PutChar(*pdata++);
		c--;
	}
  #ifdef _OPT_SRAM_
	Msg_End_Routine();
  #else
	Send_Message();
  #endif
}
#endif

#ifdef _OPT_SRAM_
/*============================================================================
O: Msg_Start_Routine
------------------------------------------------------------------------------
ړI: ߹ĊJnڍׂQTouch Studio֑M
: ޲Ăł߹Ē
o: Ȃ
: ް2iްłB
============================================================================*/
static void Msg_Start_Routine (uint16_t msg_length)
{
	PutChar (0x1B);
	packet_crc = 0;
	PutChar ((uint8_t)msg_length >> 8);
	PutChar ((uint8_t)msg_length);
	SequenceL= (SequenceL+1)& 0x0F;
	PutChar ((SequenceH<<4)+SequenceL);
}

/*============================================================================
O: Msg_End_Routine
------------------------------------------------------------------------------
ړI: ߹CRCQTouch Studio֑M
: Ȃ
o: Ȃ
: ް2iްłB
============================================================================*/
static void Msg_End_Routine (void)
{
	PutChar (packet_crc);
}
#endif
#endif
/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-EOF-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
